document.addEventListener("DOMContentLoaded", function(event) {
  /*
      ====
         MOBILE MENU
      ====
  */
  var menucall = document.getElementById("call-mobile-menu");
  var mainmenu = document.getElementById("main-menu");

  menucall.addEventListener("click", function (e) {
      menucall.classList.toggle("menu-on-l");
      mainmenu.classList.toggle("menu-on-l");
  });

  mainmenu.addEventListener("click", function (e) {
      menucall.classList.toggle("menu-on-l");
      mainmenu.classList.toggle("menu-on-l");
  });
});  // END of EventListener "DOMContentLoaded"


/********************
 
********************/
function launchLoadingScripts(launchType){
  if (launchType == undefined) {
      launchType = 'auto'
  }
  setTimeout(() => {
    console.log("dom loaded + timeout")
    let destination = document.location.pathname;
    //change instance name placeholder w/ hostname
    addInstanceName();
    socialMediaShare(self,'DOMContentLoaded');
    /**
     * Action group scripts 
     *    TODO: REVIEW PLACEMENT AS IS LAUNCHED EVERYWHERE
     **/
    scriptLauncherActions(destination,launchType);
    refreshSolidMapSrc();
    const allAppForms = document.querySelectorAll("sib-form,solid-form");
    //listen for forms in order to refresh linked displays
    allAppForms.forEach(appForm => {
      //listen for a form submit
      appForm.addEventListener("submit", (formSubmitEvent)=>{
        formSubmitEvent.preventDefault();
        // formSubmitEvent.stopPropagation();
        // formSubmitEvent.stopPropagation = true;
        // formSubmitEvent.preventDefault ;
        // formSubmitEvent.cancelBubble = true;
        
        //when there's a submit than update the display with same src
        formId = appForm.id;
        console.log('submitting form, refresh displays',formId)
        //if it's a map related form, update solid map, else update display
        if (formId.includes('map')) {
          // console.log("map form submit",formId);
          refreshSolidMapSrc();
        } else {
          //if there's a dialog pop up, listen for it first
          let validationDialog = appForm?.querySelector("dialog");
          if (validationDialog){
            //confirtion button always first
            let confirmationButton = validationDialog.querySelector('button');
            // console.log('conf button',confirmationButton);
            confirmationButton.addEventListener("click", (repContactFormDialogClickEvent)=>{
              repContactFormDialogClickEvent.preventDefault();
              repContactFormDialogClickEvent.stopPropagation();
              console.log('validation button clicked');
              refreshSolidDisplaySrc(appForm);
            })
          }
          else{
            // console.log("no confirmation, refreshing display",appForm,validationDialog);
            refreshSolidDisplaySrc(appForm);
          }
        }          
      });
      //wait for the form to populate
      // appForm.addEventListener("populate", (appFormPopulateEvent) => { 
      // }); 
    });
    //Listen for language switches
    const languageForm = document?.querySelector(".language-switch");
    console.log("presence of language switch?",languageForm);
    if (languageForm) {
      manageSelectLanguage(languageForm);
    }
    /**********
     * navigate listener to launch scripts
    ***********/
    const firstRouter = document.querySelector("solid-router");
    //scroll to top on navigate
     document.addEventListener('navigate', (e) => {
      console.log("navigating");
        e.preventDefault();
        e.stopPropagation();
        e.stopImmediatePropagation();
       setTimeout(() => {
        // console.log("first router nav scroll top",e);
          window.scrollTo({ top: 0});
      }, 0);
    });
     /*Action pages listeners */
    if (document.location.pathname.includes('action')){
      console.log("action page navigate listener");
      let actionPageRouter = document.querySelector("solid-router[id='action-groups-router']");
      actionPageRouter.addEventListener('navigate', (e) => {
        // console.log('action page nav');
        if(e.type!='DOMContentLoaded'){
          let destination = e.detail.route;
          // console.log('action page nav not dom');
          //if action group page;
          let route = e.detail.route
          if (route.includes('action-group-detail')){
            // console.log("action page",route);
            /**
             * Action group scripts
             **/
            setTimeout(() => {
              scriptLauncherActions(destination);
              refreshSolidMapSrc();
            }, 5);
          }
        }
      });
    }
    /* Consultation page listiner
    */
    if (document.location.pathname.includes('consultation')){
      console.log("consultation page");
      // Add populate listener of title to launch scripts
      consultationPageLauncher()
      let consultationPageRouter = document.querySelector("solid-router[id='consultation-router']");
      consultationPageRouter.addEventListener('navigate', (e) => {
        console.log("in consultation page navigate listener");
      })

    }
  }, 500);
}

function consultationPageLauncher() {
  let page = document.querySelector('#consultation-detail');
  displayRandomElement(page,'argumentaire')
  // page.querySelector("solid-display").addEventListener("populate", () => {
  //   alert("consultation page populate")
  // });
}

/************
 * Choose consultation texte within proposed ones
 * @param {location} location of the clic to make the choice
************/
function consultationChooseOption(location){
  console.log('choosing consultation',location);
  let tousArgumentaire = location.closest('section').querySelectorAll('solid-display-div-multiline[name*=argumentaire]');
  // only select displayed arguments
  tousArgumentaire.forEach(argumentaireProposer => {
    let displayStatus = argumentaireProposer.style.display
    if (displayStatus != "none") {
      argumentaire = argumentaireProposer.querySelector("div").innerText
      console.log("l'argumentaire affiché c'est",argumentaire);
    }
  });
  //clean opening spaces or backlines
  console.log('search',argumentaire,argumentaire.replace('^(\n|\s*)',''));
  
  // now that we have the chosen content, populate custom from & navigate there
  let customizationForm = document.querySelector("solid-form[name=consultationStep__customize] textarea");
  console.log("target form",customizationForm,customizationForm.value);
  customizationForm.value = argumentaire;
}

/************
 * scroll to somewhere
 * @param {string} scroll to target or querySelector needed
 * @param {html} where to scroll
 * * @param {string} where the destination should be on navigator (start, center, end,.. )
************/
function scrollToDestination(targetType,destination,blockDestination) {
  if (!blockDestination) {
    blockDestination = 'center'
  }
  console.log("scroll to destination",targetType,destination);
  // element to navigate to is given
  if (targetType == 'targetElement') {
    destination.scrollIntoView({ behavior: "smooth",block: blockDestination});
  } 
  // ID of element givent query selector needed
  else if (targetType == 'targetID') {
    destination = document.querySelector("#"+destination);
    console.log("destination is",destination);
    destination.scrollIntoView({ behavior: "smooth",block: blockDestination});
  }
}


/************
 * From a set of solid display, display random one and hide others
 * @param {html} page where we are
 * @param {string} String that is share between displays we want to randomize
************/
function displayRandomElement(page,elementToRandomize) {
  let elementsToRandomize = page.querySelectorAll("solid-display-div-multiline[name*="+elementToRandomize+"]")
  let lengthOfElements = elementsToRandomize.length
  let randomElement = getRndInteger(1,lengthOfElements)
  console.log("We want to randomize",elementToRandomize+" Matches are",elementsToRandomize,lengthOfElements,randomElement);
  // now that we have the elements & random number, display only random one
  elementsToRandomize.forEach(element => {
    element.style.display = 'none';
  });
  elementsToRandomize[randomElement-1].style.display = 'block'

}

/***********************
  Action Page launchers 
  * @param {event} e - DOMLoad or Navigation event launching the scripts 
  * @param {string} destination  - URI of page
***********************/
function scriptLauncherActions(destination,launchType){
  if (launchType == undefined) {
    launchType = 'auto'
  }
  console.log("action page script launcher",launchType,"destination is",destination);
  //rename destination for queryselector
  destination = "action-group-detail-home";
  /**
   * VISIBILITY CONTROLER
   */
  //get all elements that have visiblity controler
  const visibilitySections = document.querySelectorAll("#"+destination+" .visibility-controler");
  // console.log("visibility sections",visibilitySections);
  visibilitySections.forEach(visibilitySection => {
    let visibilitySolidDisplay = visibilitySection.querySelector('solid-display');
    let parentSection = visibilitySolidDisplay?.closest("section");
    let parentSectionId = parentSection.id
    if (launchType == 'manual') {
      if (parentSectionId == 'representative-targetting-type' ){
          console.log("Display targetting bloc",parentSection);
          visibilityControlerTargettedMethod(parentSection);
      }
      else if (visibilitySolidDisplay.classList.value.includes("display-action-step")){
          // console.log("action step",visibilitySection);
          visibilityControlerActionStep(visibilitySection);
          // console.log("action step styling",visibilitySolidDisplay);
          styleActiveActionStep(visibilitySolidDisplay);  
      }
      else{
        visibilityControler(visibilitySolidDisplay,parentSection);
      }
      //scroll to contact rep section
      let contactRepSection = document.querySelector("#global-representative-targeting")
      scrollTo(document.body, contactRepSection.offsetTop, 600);
    }
    
    //ISSUE with depending on populate event below
    // > When navigator loads fast, the populate event has already passed

    // Bit of a crappy fix  below
    // 1. check if content has loaded
    // 2. lauch the needed scripts, else do listen for pupulate
    if (visibilitySolidDisplay.textContent.trim() != '' ) {
      // console.log("not empty '"+visibilitySolidDisplay.textContent.trim()+"'",visibilitySolidDisplay);
      if (parentSectionId == 'representative-targetting-type' ){
        // console.log("Display targetting bloc",parentSection);
        visibilityControlerTargettedMethod(parentSection);
      }
      else if (visibilitySolidDisplay.classList.value.includes("display-action-step")){
        // console.log("action step",visibilitySection);
        visibilityControlerActionStep(visibilitySection);
        // console.log("action step styling",visibilitySolidDisplay);
        styleActiveActionStep(visibilitySolidDisplay);  
      }
      else{
        visibilityControler(visibilitySolidDisplay,parentSection);
      }
    }
    else{
      // console.log("empty",visibilitySolidDisplay.textContent.trim());
      visibilitySolidDisplay.addEventListener('populate',() => {
          // console.log("display populating",visibilitySolidDisplay);
          if (parentSectionId == 'representative-targetting-type' ){
            setTimeout(() => {
              console.log("Display targetting bloc",parentSection);
              visibilityControlerTargettedMethod(parentSection);
            }, 500);
          }
          else if (visibilitySolidDisplay.classList.value.includes("display-action-step")){
            setTimeout(() => {
              // console.log("action step",visibilitySection);
              visibilityControlerActionStep(visibilitySection);
              // console.log("action step styling",visibilitySolidDisplay);
              styleActiveActionStep(visibilitySolidDisplay);  
            }, 5000);
          }
          else{
            setTimeout(() => {
              visibilityControler(visibilitySolidDisplay,parentSection);
            }, 500);
          }
            
        })
    }
  });
}


function getRndInteger(min, max) {
  return Math.floor(Math.random() * (max - min + 1) ) + min;
}

/*#####################################################
  ***** GLOBAL SCRIPTS *****
#####################################################*/

/********************
    On click of parent it show/hides child 
********************/
function showHideBlocks(parentBlock, childBlock,style){
  //get values of current click
  this.parentBlock = parentBlock;
  this.childBlock = childBlock;
  this.style = style;
  // console.log(parentBlock,childBlock);  
  //select html
  parentBlock = document.querySelectorAll(parentBlock);
  contentToDisplay = document.querySelectorAll(childBlock);
  // console.log(parentBlock,contentToDisplay);
  for (i = 0; i < contentToDisplay.length; i++) {
    //change display
    if (contentToDisplay[i].style.display == 'none' || contentToDisplay[i].style.display == '' ) {
      contentToDisplay[i].style.display = style;
    }
    else {
      contentToDisplay[i].style.display = 'none';
    }
  }
}



/************
 * Display a target element
 * @param {*} clickElement element clic location used to update text
 * @param {*} targetElement element to display
 * @param {*} style wanted style
 * @param {*} newText optional - if we want to change the text of the button
************/
function displayElement(clickElement,targetElementId,style,newText){
  console.log("display element",clickElement,targetElementId);
  if (!newText) {
    newText = null
  }
  //display element
  console.log(document.querySelector(targetElementId).style.display,document.querySelector(targetElementId));
  document.querySelector(targetElementId).style.display = style;

  if (newText){
    clickText = clickElement.innerText;
    console.log("there's a new text wanted",newText,clickText);
    clickElement.lastElementChild.innerText = newText;
  }

}

/************
 * Hide a target element
 * @param {*} target element to hide
 * @param {*} display new style (default == none)
 * @param {*} wantedTimeout Add timeout to script, useful for solid-link
************/
function hideElement(target,display,wantedTimeout){
  if (!display || display == '') {
    display = 'none'
  }
  if (!wantedTimeout || wantedTimeout == '') {
    wantedTimeout = 0
  }
  setTimeout(() => {
    document.querySelector(target).style.display = display;
  }, wantedTimeout);
}



/************
 * Copy element
 * @param {string} type of element to copy
 * @param {string} element to copy
************/

function copyElement(type,element){
  if (!type) {
    type = 'default'
  }
  if (type == 'consultationText') {
    try {
      console.log('copying consultation text, start',type,element);
      let tousArgumentaire = element.closest('div').querySelectorAll('solid-display-div-multiline[name*=argumentaire]');
      // FOR RANDOM, only select displayed arguments
      tousArgumentaire.forEach(argumentaireProposer => {
        let displayStatus = argumentaireProposer.style.display
        if (displayStatus != "none") {
          argumentaire = argumentaireProposer
          console.log("l'argumentaire affiché c'est",argumentaireProposer);
        }
      });
      //copy element
      const storage = document.createElement('textarea');
      // storage.style.display = 'none';
      storage.value = argumentaire.innerText;
      argumentaire.appendChild(storage);
      console.log("argumentaire is",storage.value);
  
      // Copy the text in the fake `textarea` and remove the `textarea`
      storage.select();
      storage.setSelectionRange(0, 99999);
      document.execCommand('copy');
      navigator.clipboard.writeText(storage.value);
      argumentaire.removeChild(storage);
      alert("L'argumentaire a été copié",storage.value);
      // Alert the copied text
      
    } catch (error) {
      alert("Une erreur est survenu lors du copier/coller",error)
    }
  }
  else if ((type == 'formText') || (type == 'default')) {
    console.log('copying element type',type,' and element ',element);
    if (type == 'default') {
      elementToCopie = document.createElement('input');
      // elementToCopie.createElement('input').add
      elementToCopie.value = element;
      // elementToCopie = element;
    } else {
      elementToCopie = document.querySelector("*[name="+element+"] *");
    }
    // console.log(elementToCopie,elementToCopie.innerText,elementToCopie.value);
    //copy element
    const storage = document.createElement('textarea');
    // storage.style.display = 'none';
    storage.value = elementToCopie.value;
    elementToCopie.appendChild(storage);
    // console.log("argumentaire is",storage.value);

    // Copy the text in the fake `textarea` and remove the `textarea`
    storage.select();
    storage.setSelectionRange(0, 99999);
    document.execCommand('copy');
    navigator.clipboard.writeText(storage.value).then(
      () => {
        /* clipboard successfully set */
        if (type == 'formText') {
          window.alert("Le texte "+storage.value+" a été copié",);    
        } else {
          window.alert(storage.value+" a bien été copié",);
        }
      },
      (e) => {
        window.alert('Il y aune erreur lors du copier',e)
        /* clipboard write failed */
      },
    );
    elementToCopie.removeChild(storage);
  }
}

  /***********************
          Form validation scripts
  ***********************/

/*Global Listener function*/
function checkFormValidity(formClickEvent,form) {
  // console.log("form checker",form);
  var originalContent = form.querySelector("textarea[name=emailContent]");
  //if naked form than do nothing
  if (!form.querySelector("[type=submit]")) {
    // console.log("naked form");
  }
  else{
    //check for id 
    const formId = form.id;
    var currentErrors = [];
    var errorDiv = form.nextElementSibling;
    //check the fiels of the wanted forms
    // console.log("current form is",formId);
    switch(formId){
      case "solid-form-add-actiongroup":
          //CheckMandatoryField(formClickEvent,"input[name=name]","Nom");
          //CheckMandatoryField(formClickEvent,"input[name=objective]","Objectif");
          //CheckMandatoryField(formClickEvent,"textarea[name=description]","Description");
          //validateCheckBoxes(formClickEvent,"Modalité d'interpellation");
          break;
     
      case "representative-email-send-form" :
          //CheckEmailFormat();
          CheckEmailContentChange(form);
          break;
      case "email-form" :
          CheckMandatoryField("input[name=userName]","Noms");
          CheckMandatoryField("input[name=userEmail]","Email");
          //uncomment bellow to make newsletter mandatory
          //CheckMandatoryField("select[name=newsLetterSignUp]","Newsletter");
          CheckMandatoryField("input[name=representativeEmails]","Adresse de vos élu.e.s");
          CheckEmailFormat();
          CheckEmailContentChange(form);
          break;    
      case 'organisation-add-support-form':
          CheckMandatoryField("input[name=name]","Nom de votre organisation");
          CheckUrlFormat("input[name=website]","Veuillez commencer votre URL avec \"http://\" ou \"https://\" ");
          break;

      default:
        // console.log("form not handled");
        break;
    }
    //display errors
    showErrors(currentErrors,errorDiv,formId);
  
    /***********
    check email format
    ***********/
    function CheckUrlFormat(tagName,errorMessage){
      let tag = tagName;
      errorMessage = errorMessage;
      let urlField = form.querySelector(tag);

      let urlRegEx = /^(https:\/\/|http:\/\/)/;
      // console.log("field",urlField.value,"regext test",urlRegEx.test(urlField));
      if(urlRegEx.test(urlField.value) == false && !urlField.value == ""){
        currentErrors.push(errorMessage);
        // console.log("wrong url format");
        form.querySelector(tag).classList.add("error-field");
        // event.preventDefault();
      }
      else{
        form.querySelector(tag).classList.remove("error-field");
        form.querySelector(tag).classList.add("validated-error-field");
      }
      
    }
    

    /*======
          Functions bellow
            && !emailPlaceholder.includes(electedText)
    ======*/ 
    /***********
    check email format
    ***********/
    function CheckEmailFormat(){
      var emailRegEx = /^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/;

      allFields = form.querySelectorAll("input");             
      for (i = 0; i < allFields.length; i++) {

        let emailPlaceholder = (allFields[i].placeholder).toLowerCase();
        let emailText = "email";
        let electedText = "élu";

        emailValue = allFields[i].value;
        if (emailPlaceholder.includes(emailText)) {

          //if elected official field, pass by
          if (emailPlaceholder.includes(electedText)) {
            // console.log("elected field");
          }
          //if email feild && not empty, check value
          else if (emailRegEx.test(emailValue) == false && emailValue.length != 0 && !(emailPlaceholder.includes(electedText)) ) {
            currentErrors.push("Le format de votre adresse email contient une erreur");
            // console.log(allFields[i]);
            allFields[i].classList.add("error-field");
            // event.preventDefault();
          }

          else{
            // console.log("not an elected official form");
          }
        }
      }
    }


    function CheckEmailContentChange(form){
      originalValue = document.querySelector("#email-representatives div[name=electedofficialemailtext]").textContent;
      currentValue = form.querySelector("textarea[name=content]").value;
      // console.log("email values",originalValue,currentValue);
      if (originalValue == currentValue) {
          currentErrors.push("veuillez personnaliser le contenu de l'email. Plus votre message est personnalisé l'impact sera fort auprès de vos élu.e.s.");
          // event.preventDefault();
          // event.stopPropagation();
        }
    }

    /***********
    check the mandatory fields
    ***********/
    function CheckMandatoryField(formClickEvent,tagName,ErrorValue){
      //get tag name to be checked
      this.tagName = tagName;
      this.ErrorValue = ErrorValue;

     
      //else check the value of mandatory field
      if (form?.querySelector(this.tagName)?.value == "") {
          //formSubmitEvent.cancelBubble = true;
          //formSubmitEvent.stopPropagation();
          formClickEvent.preventDefault();
          //if there's an error get it & push it to array
          currentErrors.push(this.ErrorValue);
          // console.log("form",form,tagName);
          form.querySelector(tagName).classList.remove("validated-error-field");
          form.querySelector(tagName).classList.add("error-field");
          
      }
      else{
          form.querySelector(tagName).classList.remove("error-field");
          form.querySelector(tagName).classList.add("validated-error-field");
      }
    }

    function validateCheckBoxes(formClickEvent,ErrorValue){
      anySelected = false
      let checkBoxes = form.querySelectorAll("input[type=checkbox]");
      checkBoxes.forEach(checkBoxe => {
        let selected = checkBoxe.checked
        if (selected == true) {
          anySelected = true
        }
        // console.log("selected boxes",anySelected);
      });
      //of no checkboxes are selected, push error
      if (anySelected == false){
        formClickEvent.preventDefault();
        currentErrors.push(ErrorValue);
        attributeRequired(form,'div[name=selection-contact-platforms]','add');
      }
      else {
        attributeRequired(form,'div[name=selection-contact-platforms]','remove');
      }
    }

    /***********
    get the errors & display them
    ***********/
    function showErrors(errors,errorDiv,formId){
      if (errors.length==1) {
        errorDiv.innerHTML = "Le champs \"" + currentErrors.join(", ") + "\" est obligatoire";
        errorDiv.classList.add("show");
      }
      else if (errors.length>1) {
        errors.splice((errors.length)-1,0," et ");
        var errorMessage = "Les champs suivants sont obligatoires : \""+ currentErrors.join(", ") + "\"";
        errorMessage = errorMessage.replace(",  et ,"," et ");
        errorDiv.innerHTML = errorMessage;
        errorDiv.classList.add("show");
      }
      else{
            errorDiv.classList.remove("show");
            errorDiv.classList.add("hide");
            errorDiv.classList.add("validate");

            //this.formId = formId; 
            // console.log("here here");
            // console.log(formId);

          //personnalise confimation message depending on the form
        if (this.formId == "support-legalization-form" ) {
              errorDiv.innerHTML = "Votre soutien a été validé";   
          }
          else if (this.formId == "email-form" || this.formId == "solid-form-add-actiongroup" ){
              errorDiv.innerHTML = "Le formulaire est valide et va être envoyé. Vous serez mis en copie de l'email envoyé."; 
          }
          else if (formId == "organisation-add-support-form" ){
              errorDiv.innerHTML = "Votre organisation a bien été ajouté. Rafraichissez la page pour voir le changement."; 
          }

          else{
            errorDiv.innerHTML = "Le formulaire est validé."; 
          }
      
      }
    }
  };

};

/*=
Refresh Solid Display datasrc
=*/
function refreshSolidDisplaySrc(form,displayId) {
  queryParameters = {'new':'?','add':'&'}
  defaultQueryParameter = queryParameters['new']
  //get source of the form
  let formSrc = form.dataset.src;
  //break it into URL in order to only select domain & uri for later on
  const formSrcUrl = new URL(formSrc);
  formPath = formSrcUrl.pathname;
  //if theres a display informed, than update that display's src right away
  if (typeof display !== 'undefined' ) {
    // console.log("refreshing known display",sibDisplay);
    //select the datasrc value
    displaySource = document.querySelector(displayId).dataset.src;
    //make a URL of it
    const displaySourceUrl = new URL(displaySource);
    //refresh the source with reconstructed URL to + cache break
    displayId.dataset.src = displaySourceUrl.origin + displaySourceUrl.pathname + defaultQueryParameter + Math.random();
  }
  //if it's a representative form, refresh counter
  else if (form.id.includes("representative-email-send-form")) {
    emailCounter = document?.querySelector('solid-display#email-counter-display')
    //if there's a counter, update it
    if (emailCounter) {
      setTimeout(() => {
        let emailCounterDataSrc = emailCounter.dataset.src
        const emailCounterUrl = new URL(emailCounterDataSrc);
        if (emailCounterDataSrc.includes('?')) {
          emailCounterDataSrc = emailCounterUrl.origin + emailCounterUrl.pathname
        }
        emailCounter.dataset.src = emailCounterDataSrc + defaultQueryParameter + Math.random();
      }, 1500);
    }
  }
  else{
    //select each display
    let sibDisplays = document.querySelectorAll("solid-display");
    //for each display get its data src
    sibDisplays.forEach(sibDisplay => {
      // console.log("refreshing all display",sibDisplay);
      let sibDisplaySrc = sibDisplay.dataset.src;
      if(sibDisplaySrc){
        //if there's a URL, check if it matches the form src
        const displaySrcUrl = new URL(sibDisplaySrc);
        sibDisplayPath = displaySrcUrl.pathname;
        // console.log("updating display url",formPath,sibDisplayPath);
        if (sibDisplayPath == formPath){
          //if it does, refresh it
          if (formSrc.includes('?')) {
            formSrc = formSrcUrl.origin + formSrcUrl.pathname
          }
          sibDisplay.dataset.src = formSrc + defaultQueryParameter + Math.random() ;
        }
      }
    });
  }        
}


/***********************
  Refresh Solid Map Datasct
   {HTMLElement} appForm - Form linked to the map
***********************/
function refreshSolidMapSrc(){
  setTimeout(() => {
    //select cur  rent page
    let page = document.querySelector("#action-group-detail-home");
    //get map on current page
    let map = page.querySelector("solid-map");
    refreshComponent(map);
  }, 1000);
}

function refreshComponent(component) {
  var dataSource = component.attributes['data-src']?.value;
  console.log('refreshing component',component,'data src',dataSource);
  
  // With federation, some datasources become "#"
  //exclude them
  if (dataSource) {
    if(dataSource != '#'){
      const url = new URL(dataSource);
      var newUrl = url.origin + url.pathname + '?' + Math.random()
      // console.log("Refreshing component with url",url,url.href,'new url',newUrl);
      component.attributes['data-src'].value = newUrl;
    }
  }
}

/*===========
    * Add instance name 
 =*/

 function addInstanceName() {
  let instancePlaceHolders = document.querySelectorAll("#localInstanceName");
  // console.log("add instance",instancePlaceHolders);
  let instanceName = window.location.hostname;
  instanceName = instanceName.split("-").join(" ");
  instanceName = instanceName.charAt(0).toUpperCase() + instanceName.slice(1);

  instancePlaceHolders.forEach(instancePlaceHolder => {
    let placeholder = instancePlaceHolder.textContent;
    // console.log("text is",placeholder,instanceName);
    instancePlaceHolder.textContent = instanceName;
  });
}




/*#####################################################
            ***** ACTION GROUPS *****
#####################################################*/

/*=
    * Social media share buttons 
 =*/
function socialMediaShare(self,eventSocialMediaShare){
  // console.log("start social media share");

  eventSocialMediaShare.stopPropagation = true;
  eventSocialMediaShare.cancelBubble = true;
   eventSocialMediaShare.preventDefault ;
  // eventSocialMediaShare.stopPropagation() && eventSocialMediaShare.stopPropagation;
  eventSocialMediaShare.cancelBubble = true;
  eventSocialMediaShare.bubbles = false;
  // console.log("social media share",self,eventSocialMediaShare);
  var shareButtons= document.querySelectorAll('#share-bar a,#top-share-bar a')
  /***
      * Detect device, if we're on mobile
      * open dialog box & allow user to choose 
      * between opening in app or nav
      ***/
  let device = getMobileOperatingSystem();
  let deviceIsMobile = false;
  if (device != 'unknown'){
    // console.log("we're on mobile",device);
    deviceIsMobile = true;
  }
  if (shareButtons) {
    shareButtons.forEach(shareButton => {   
      // console.log("share text",shareText)
      shareButton.addEventListener("click", (eventShareButton) => {  

        //if action groups
        if (window.location.pathname.includes('action-group-detail')) {
          console.log('action page'); 
          //get objective to use as share text
          var shareTitle = document?.querySelector("[class=h1-like]")?.innerText;
          if (shareTitle == undefined) {
            shareTitle =  document?.querySelector("title")?.innerText
          }
          var shareObjective = document?.querySelector("div[id=action-group-detail-home] solid-display[name=action-objective] div[name=objective]").innerText;
          if (shareObjective== undefined) {
            shareObjective = document?.querySelector('meta[name=description]')?.content
          }
        }
        else{
          var shareTitle = document.querySelector("title")?.innerText
          var shareObjective = document.querySelector('meta[name=description]')?.content
        }
        // console.log("share title",shareTitle,"objective",shareObjective);
        let shareText = shareTitle + ".\n" + shareObjective

        //make just first letter a capital
        shareText = shareText.toLowerCase();
        shareText = shareText.charAt(0).toUpperCase() + shareText.slice(1)

        //encode texte
        shareText = encodeURI(shareText);
        //encode # seperately
        shareText = shareText.replace(/#/g, '%23'); 
        //set share url
        let currentPageUrl = document?.querySelector('solid-display-value[name="shortLink.shortLink"]')?.textContent;
        //handle cases where no short links
        if (currentPageUrl == location.origin) {
          currentPageUrl = location.href;
        }
        else if(currentPageUrl == undefined||currentPageUrl.includes("undefined")){
          currentPageUrl = location.origin  + location.pathname
        }
        //remove anchor in URL, if there's one
        currentPageUrl = currentPageUrl.replace(/#\w+.*/,'');
        // console.log("click",shareButton);
        eventShareButton.stopPropagation = true;
        eventShareButton.preventDefault() && eventShareButton.preventDefault ;
        eventShareButton.bubbles = false;
        eventShareButton.cancelBubble = true;
        
        // console.log("share button event is",eventShareButton,eventShareButton.bubbles);       
        /***
         * Share platform needs to be determined here due to 
         * unresolved issue.
         * Workaround of issue resets plateform as null after click,
         * To allow user to reclic without reloading, we need to keep it here
         
          *THE ISSUE: 
          * if click on multiple, or close & pick another platform
          * the events add up and openLinkInApps or InNav is launched for each
          * time it was clicked
        */
        //select classes to determine which platform was used
        let classList = shareButton.classList;
        let socialClass = classList.value;
        //clean is and use as base for the switch
        let sharePlateform = socialClass.split("is-").join(""); 
        sharePlateform = sharePlateform.trim();
        console.log("share platform is",sharePlateform,shareText);
        if ((deviceIsMobile == true) && (sharePlateform != 'copy-link')){  
          // console.log("copy is mobile or not copy link");
          displayDialogOpenAppOrNav(sharePlateform,shareText,currentPageUrl,eventShareButton);
        }
        else if (sharePlateform == 'copy-link') {
          copyElement('default',currentPageUrl)
        }
        else{
          // console.log("copy not mobile or copy link");
          openLinksInNav(sharePlateform,shareText,currentPageUrl);
          // console.log("after const",sharePlateform);
        }
      }); 
    });
  }
}


function displayDialogOpenAppOrNav(sharePlateform,shareText,currentPageUrl,eventShareButton) {
  //select dialog & display it
  let dialog = document.querySelector('dialog#choose-app-navigator');
  dialog.style.display = 'flex';
  //listen for clicks
  let dialogButtons = dialog.querySelectorAll('button#app,button#nav,div#close');
  // console.log("dialog buttons are",dialogButtons);
  dialogButtons.forEach(dialogButton => {
    dialogButton.addEventListener("click", function (dialogClickEvent) {
      // dialogClickEvent.stopImmediatePropagation();
      // dialogClickEvent.stopPropagation();
      dialogClickEvent.stopPropagation = true;
      dialogClickEvent.preventDefault() && dialogClickEvent.preventDefault ;
      // dialogClickEvent.stopPropagation();
      dialogClickEvent.stopPropagation = true; 
      dialogClickEvent.bubbles = false;
      // console.log("shareplatform is ",sharePlateform,dialogClickEvent);

      let clickElement = dialogClickEvent.target.id;
      // console.log("click on element",sharePlateform,clickElement,dialogClickEvent)
      //check clic types
      if((clickElement == 'app' ) && (sharePlateform != null) ){
        openLinkInApps(sharePlateform,shareText,currentPageUrl,eventShareButton);
        //make null orelse keeps if click on multiple 
        // platforms one after another the event is launched multiple times
        sharePlateform = null;
      }
      else if ((clickElement == 'nav') && (sharePlateform != null)) {
        openLinksInNav(sharePlateform,shareText,currentPageUrl);
        sharePlateform = null;
      }
      else if((clickElement == 'close') || (clickElement == '') ) {
        sharePlateform = null;
        // console.log("chose to close, clear event",sharePlateform);
      }
      //if don't hide, then sharePlateform stays Null 
      // next clicks
      dialog.style.display = 'none';
    });
  });
  //listen for close click on dialog box
  let dialogClose = dialog.querySelector('.close');
  dialogClose.addEventListener("click", function () {
    // dialog.removeAttribute('open');
    dialog.style.display = 'none';
  });
}


/***********************
    *Tweet message to elected official 
 ***********************/
function TwitterEOMultipleContentOptions(clickLocation){
    // console.log("location of click",clickLocation);
    var HomeUrl = location.href ;
    let representativeTwitterAccounts = "";
    let twitterAccounts = "";
    //get the displays of all representative above the click

    let representativeDisplays = clickLocation?.closest("#twitter-multiple-choices,#manual-contact-content-twitter").querySelector("#representatives-search-module > solid-display,u4e-targeted-representative-widget > solid-display").querySelectorAll(":scope > div > solid-display");
    // console.log("representative displays",representativeDisplays);
    //check if any representatives are selected
    let checkedItems = 0
    representativeDisplays.forEach(representativeDisplay => {
      // console.log("current display",representativeDisplay);
      //count the number of checked items
      let box = representativeDisplay?.querySelector("input[type=checkbox]")?.checked;
      // console.log("representative box",box);
      if (box == true) {
        checkedItems = checkedItems + 1;
      }
    });

    if (checkedItems == 0) {
      attributeRequired(representativeDisplays,'div[name=select]','add');
      //window.alert("vous n'avez pas séléctionné de compte");
    // else get the values of content & share tweet
    } else {
      //remove required
      attributeRequired(representativeDisplays,'div[name=select]','remove');
      representativeDisplays.forEach(representativeDisplay => {
        //see if the representative is selected
        selectedRepresentative = representativeDisplay?.querySelector("input[type=checkbox]")?.checked;
        if (selectedRepresentative == true) {
          // console.log("checked representative",selectedRepresentative);
          //get the twitter accounts
          twitterAccounts = representativeDisplay.querySelectorAll("solid-multiple-div[name=twitterAccount] solid-display-value[name=name]");
          // console.log("accounts",twitterAccounts);
          //for each account, add it to the list
          twitterAccounts.forEach(twitterAccount => {
            twitterAccount = twitterAccount.textContent;
            //if it's a twitter url, clean it
            if (twitterAccount.includes("https")) {
              twitterAccount = twitterAccount.split('https\:\/\/twitter.com\/').join('@');
              twitterAccount = twitterAccount.split('https\:\/\/x.com\/').join('@');
              twitterAccount = twitterAccount.replace('@@','@')
            }
            else if(twitterAccount.includes("@") == false && twitterAccount != ""){
              // console.log("does not contain an '@'",twitterAccount);
              twitterAccount = '@' + twitterAccount;
            }
            representativeTwitterAccounts = representativeTwitterAccounts + " " + twitterAccount;
            // console.log("accounts",representativeTwitterAccounts);
          });
        }      
      });
    }    
    //get chosen content
    var SelectedTwitterContent = clickLocation?.parentElement.querySelector(".tabs-stage .tab-active").textContent;
    representativeTwitterAccounts = representativeTwitterAccounts.split(' undefined').join("");
    //Current URL added in alleo_account if no account found, so here we clean it
    representativeTwitterAccounts = representativeTwitterAccounts.split(HomeUrl).join("");    
    
    // console.log("all tweets",SelectedTwitterContent,representativeTwitterAccounts);
    /**
     * If there's the content "@CompteACibler" in content then place tags there
     */
    var tweet = ""
    if (SelectedTwitterContent.toLowerCase().includes('compteacibler') || SelectedTwitterContent.toLowerCase().includes('chosenaccounts') ){
      SelectedTwitterContent = SelectedTwitterContent.toLowerCase().replace("@compteacibler","@CompteACibler").replace("@chosenaccounts","@CompteACibler")
      // console.log("tweet is",SelectedTwitterContent);
      tweet = SelectedTwitterContent.split('@CompteACibler').join(representativeTwitterAccounts);
      // console.log("compte à cibler dans le text",tweet);
    }
    else {
      // now build full tweet
      tweet= SelectedTwitterContent + " " + representativeTwitterAccounts ; 
    }
    //remove multiple spaces & backspaces
    tweet = tweet.replace(/\n/g," ");
    tweet = tweet.replace(/\s+/g," ");
    
    /**
     * Set current url
     */
    //get shortlink
    let currentPageUrl = document?.querySelector('solid-display-value[name="shortLink.shortLink"]')?.textContent;
    // console.log("twitter url is",currentPageUrl)
    //handle cases where no short links
    
    if (currentPageUrl == location.origin) {
      currentPageUrl = location.origin + location.href;
    }
    else if(currentPageUrl == undefined || currentPageUrl.includes("undefined")){
      currentPageUrl = location.origin  + location.pathname
    }
    //remove anchor in URL, if there's one
    currentPageUrl = currentPageUrl.replace(/#\w+.*/,'');
    // encode it
    
    /*
    Uncomment below to display URL in tweet 
    */
    // tweet += "\n"+currentPageUrl

    var sharableTweet = encodeURI(tweet);
    //encode the # seperatly because not done in encodeURI
    var sharableTweet = sharableTweet.replace(/#/g, '%23');
    
    //get device

    //if mobile, give option to share in app
    device = getMobileOperatingSystem();
    // console.log("device is",device)
    if (device != 'unknown'){

      /*
       Uncomment below if want URL in interpellation tweet, then comment following line
      */
      // displayDialogOpenAppOrNav('twitter',sharableTweet,currentPageUrl)
      displayDialogOpenAppOrNav('twitter',sharableTweet,"")

      // console.log("open link, unknown ",device);
      // openLinkInApps('twitter',sharableTweet,'')
    }
    else{
      // console.log("open link, else",device);
      //share it
      window.open("https://twitter.com/intent/tweet?text="+ sharableTweet,'_blank');
    }
}


/***********************
    Customize chose representative fnction (rep, senators, candidates,...)
 ***********************/
function representativeSearchUpdateFunction(clickLocation){
  // console.log("representative function update",clickLocation);
  let representativeSource = clickLocation.closest("solid-display").getAttribute('data-src');
  let currentSection = clickLocation.closest("section");
  // let searchForm = currentSection.querySelector('solid-form-text[name=function]');
  
  // console.log(representativeSource,currentSection,"value is",currentSection.querySelector('solid-form-text[name=function] input').value);
  currentSection.querySelector('solid-form-text[name=function] input').value = representativeSource;

  //send onchange event7
  let form = currentSection.querySelector('solid-form-search');
  let formId = form.id;
  // var event = new Event('change');
  // console.log("sending form");
  // form.dispatchEvent(event);

  let linkedDisplays = document.querySelectorAll('solid-display[filtered-by='+formId+']');
  linkedDisplays.forEach(linkedDisplay => {
    // console.log("search display, refreshing component",linkedDisplay)
    refreshComponent(linkedDisplay);
  });

}

/***********************
    Select representatives on card click
 ***********************/
function selectRepresentativeCardClick(representativeCard){
  // console.log("current card",representativeCard);
  let representativeCheckBox = representativeCard.querySelector("input[type=checkbox]");
  let representativeCheckBoxStatus = representativeCheckBox.checked
  if (representativeCheckBoxStatus == true){
    representativeCard.classList.remove('active');
    representativeCheckBox.checked = false;
  }
  else{
    representativeCard.classList.add('active');
    representativeCheckBox.checked = true;
  }
  // console.log("clicked box",representativeCard,representativeCheckBox.classList);
}
/**
 * Listen for click on search result cards
 * @param {*} module - wanted module
 * @param {*} clickLocation - location
 */
//listening function for selectRepresentativeCardClick
function listenSelectRepresentativeCardClick(module,clickLocation){
  // console.log("click location",clickLocation);
  let currentSection = clickLocation.closest('section');
  //To avoid bug, hide any currently displayed module
  if (module.toLowerCase().includes('email')) {
    module =  'email'
  }else if (module.toLowerCase().includes('twitter')) {
    module =  'twitter'
  }else if (module.toLowerCase().includes('téléphone') || module.toLowerCase().includes('phone')) {
    module =  'phone'
  }
  
  let sectionType = "Global";
  if (currentSection.id.includes("manual")) {
    sectionType = "Manual"
  }
  var moduleSectionIds = {}
  if (sectionType == "Manual") {
    moduleSectionIds = {
      'email' : 'manual-contact-content-email',
      'twitter' : 'manual-contact-content-twitter',
      'phone' : 'manual-contact-content-call'
    }
  }
  else{
    moduleSectionIds = {
      'email' : 'representative-contact-content-email',
      'twitter' : 'representative-contact-content-twitter',
      'phone' : 'representative-contact-content-call'
    }
  }
  // console.log("current section",currentSection);
  // console.log("section id",moduleSectionIds);
  for (const moduleSectionId in moduleSectionIds) {
    // console.log("section in for",currentSection);
    currentSection.querySelector('#'+moduleSectionIds[moduleSectionId]).style.display = 'none';
  }
  //in the section, select the contact modules 
  //based on 'representative-contact-*' in their id
  let moduleSection = ""
  // console.log("before switch module",module);
  switch (module) {
    case 'email':
      moduleSection = currentSection.querySelector('#'+moduleSectionIds['email']);
      break;
    case 'twitter':
      moduleSection = currentSection.querySelector('#'+moduleSectionIds['twitter']);
      break;
    case 'phone':
      moduleSection = currentSection.querySelector('#'+moduleSectionIds['phone']);
      break;
    default:
      console.log("Display contact platform - no case match",module)
      break;
  }
  let reprensentativeSearchResults = moduleSection.querySelectorAll('.elected-search solid-display > div > solid-display');
  //clear all existing checkbox's
  let allCheckboxes = document.querySelectorAll('input[type="checkbox"]');
  allCheckboxes.forEach(allCheckboxe => {
    allCheckboxe.checked = false;
  });
  reprensentativeSearchResults.forEach(reprensentativeSearchResult => {
    reprensentativeSearchResult.addEventListener("click", function(e){
      e.preventDefault;
      e.cancelBubble;
      e.stopImmediatePropagation();
      // console.log("click",reprensentativeSearchResult);
      selectRepresentativeCardClick(reprensentativeSearchResult);
    });
  });
}


/***********************
    *Select all displayed representatives
 ***********************/
function selectAllRepresentatives(clickLocation){
  //get the line above the click
  let representativeCards = clickLocation.parentElement.previousElementSibling.querySelectorAll(':scope > div > solid-display,:scope solid-display > div > u4e-targeted-representative-widget > solid-display > div > solid-display');
  // console.log("Select all reps",representativeCards);
  //if empty, like on Twitter card, check 2nd querySelector
  if (representativeCards.length == 0) {
    representativeCards = clickLocation.previousElementSibling.querySelectorAll(":scope solid-display > div > solid-display");
  }
  checkedElement = false
  representativeCards.forEach(representativeCard => {
    // console.log("card is",representativeCard);
    //get innertext
    //if it's not "deactivate", 
    checkedElement = representativeCard.querySelector("input[type=checkbox]").checked
    // console.log("checkbox",representativeCard.querySelector("input[type=checkbox]"));
  });
  //check all cards
  representativeCards.forEach(representativeCard => {
    if (checkedElement == false){
      // console.log("checkbox no checked",checkedElement);
      representativeCard.querySelector("input[type=checkbox]").checked = true;
      representativeCard.classList.add('active');
      clickLocation.innerText = "Annuler la séléction";
    }
    else{
      // console.log("checkbox checked",checkedElement);
      //else uncheck all & place original content
      representativeCard.querySelector("input[type=checkbox]").checked = false;
      representativeCard.classList.remove('active');
      clickLocation.innerText = "Selectionner tou.te.s les élu.e.s";
    }
  });
}

/***********************
         START FUNCTION TO GET REPRESENTATIVES EMAILS
          //launches related functions
***********************/
function getEmail(clickLocation){
  // console.log("get email",clickLocation);
  var all_emails = [];
  let representativeDisplays = [];
  //select parent section
  let representativeEmailSection = clickLocation.closest('.email-module');
  // console.log("closest email section",representativeEmailSection);
  //select the representative sections
  let representativeEmailSubSections = representativeEmailSection.querySelectorAll(":scope > section");
  //for each section, get the visibility status & Keep only the displayed one
  // console.log("sections are",representativeEmailSubSections);
  representativeEmailSubSections.forEach(representativeMainDisplay => {
    let displayStatus = representativeMainDisplay.style.display;
    // console.log("section is",representativeMainDisplay,"dispay is",displayStatus);
    if (displayStatus != "none") {
      let allRepresentativeDisplays = representativeMainDisplay.querySelectorAll(":scope  solid-display > div > solid-display");
      // console.log("representatitves are", allRepresentativeDisplays);
      allRepresentativeDisplays.forEach(allRepresentativeDisplay => {
        representativeDisplays.push(allRepresentativeDisplay);
      });
    }
  });
  
  /*
   * Check if there are checked items
   */
  let checkedItems = 0
  let selectedRepresentatives = []
  // console.log("all displays are",representativeDisplays);
  representativeDisplays.forEach(representativeDisplay => {
    //count the number of checked items
    let box = representativeDisplay?.querySelector("input[type=checkbox]")?.checked;
    if (box == true) {
      checkedItems = checkedItems + 1;
      selectedRepresentatives.push(representativeDisplay);
    }
  });
  //if there's no checked email display error
  if (checkedItems == 0) {
    // console.log("checked 0 are",checkedItems);
    attributeRequired(representativeDisplays,'[name=select]','add');
  // else set the emails in form field
  } else {
    // console.log("checked else are",checkedItems,selectedRepresentatives);
    setRepresentativeEmails(all_emails,selectedRepresentatives);
    //remove checkbox required
    attributeRequired(representativeDisplays,'[name=select]','remove');
  }
}


/***********************
        GET EMAILS OF SELECTED REPRESENTATIVES 
        && PUSH THEM TO FORM FIELD 
***********************/
function setRepresentativeEmails(all_emails,selectedRepresentatives) {
  // console.log("the representative display used",selectedRepresentatives,all_emails);
  selectedRepresentatives.forEach(selectedRepresentative => {
      let representativeEmails = selectedRepresentative.querySelectorAll("solid-multiple[name=directEmails] solid-display-value,solid-multiple-div[name=directEmails] solid-display-value");
      // console.log("emails are",representativeEmails);
      representativeEmails.forEach(representativeEmail => {
        //get text content
        representativeEmail = representativeEmail.innerText;
        //remove spaces & backspaces
        representativeEmail = representativeEmail.replaceAll("\n","");
        representativeEmail = representativeEmail.replaceAll(" ","");
        if (!all_emails.includes(representativeEmail)){
          //push each value to all emails
          all_emails += representativeEmail  + ", ";
        }
      });
  });
  //clean up the final string
  // console.log("all emails",all_emails);
  if (all_emails.length != 0) {
    all_emails = all_emails.replace("undefined","");
    all_emails = all_emails.replace(/(, $)/,"");
  }
  //push content to form(s)
  let displayEmailBlocks = document.querySelectorAll(".send-email-elected-email input");
  displayEmailBlocks.forEach(displayEmailBlock => {
    displayEmailBlock.value = all_emails;
  });
}


/***********************
        ADD/REMOVE REQUIRED ATTRIBUTE OF ELEMENT(S) 
***********************/

function attributeRequired(locations,itemSelector,action) {
  //select each checkbox div
  //let checkboxDivs = representativeDisplay.querySelectorAll("div[name=select]");
  elementNodeCheck = NodeList.prototype.isPrototypeOf(locations);
  elemementArrayCheck = Array.prototype.isPrototypeOf(locations);
  // console.log("attribute location",locations,elementNodeCheck,elemementArrayCheck);

  if (elementNodeCheck == true || elemementArrayCheck == true ){
    locations.forEach(location => {
      let requiredDiv = location?.querySelector(itemSelector);
      if (requiredDiv) {
        if (action == 'add') {
          requiredDiv.setAttribute("required",true);
        }
        else if (action == 'remove' ){
          requiredDiv.setAttribute("required",false);
        }  
      }
    });
  }
  else{
    let requiredDiv = locations?.querySelector(itemSelector);
    if (requiredDiv) {
      if (action == 'add') {
        requiredDiv.setAttribute("required",true);
      }
      else if (action == 'remove' ){
        requiredDiv.setAttribute("required",false);
      }
    }
  }
}

/***********************
 * Display Modals
    * @param {string} Id id of modal wanted
**********************/

function displayModal(id) {
  const modal = document.getElementById(id);
  modal.style.display = "flex";

  let close = modal.querySelector(".close")
  close.onclick = function() {
    modal.style.display = "none";
  }
  // When the user clicks anywhere outside of the modal, close it
  window.onclick = function(e) {
    if (e.target == modal) {
      modal.style.display = "none";
    }
  }

}


/***********************
        HIDE EMPTY SECTION ON ACTION PAGE 
***********************/
function visibilityControler(solidDisplay,parentSection) {
    // console.log("visibility controler",solidDisplay,parentSection);
    let section = parentSection;
    sectionClasses = section.classList;
    sectionId = section.id;
    //handle steps seperately
    //get content of the display
    let content = solidDisplay.querySelector("div").innerText;
    // console.log("visibility div content",solidDisplay,content);
    //remove spaces in content for check
    content = content.replace(/\s/g,"");
    content = content.replace(/\n/g,"");
    // console.log("visibility div compare content",content);
    if (content == ""){
      section.style.display = "none";
    }
    else{
      section.style.display = "block";
    }
    
  setTimeout(() => {
  }, 500);
}

// Updated way to display targetted sections
function visibilityControlerTargettedMethod(section){
  // if module #representative-contact-modules is displayed, on navigate it's not hidden
  // so start by hidding it in case
  document.querySelector("#representative-contact-modules").style.display = 'none';
  chosenMethode = section.querySelector("*[name=typeOfTargetting]")?.innerText;
  console.log("Chosen method",chosenMethode)
  postalCodeTargetingBlock = document.querySelector("section#global-representative-targeting")
  specificTargetsBlock = document.querySelector("section#manual-representative-targeting")
  if (chosenMethode == "postalCode"){
    // console.log("chosenMethode is",chosenMethode," hide ",specificTargetsBlock);
    //display postal code block & hide others
    postalCodeTargetingBlock.style.display = "block";
    specificTargetsBlock.style.display = "none";
  }
  else if (chosenMethode == "specificRepresentatives"){
    // console.log("chosenMethode is",chosenMethode," hide ",postalCodeTargetingBlock);
    //display representative block& hide others
    postalCodeTargetingBlock.style.display = "none";
    specificTargetsBlock.style.display = "block";
  }
  //preperation for "geography"
  else if (chosenMethode == "byGeography"){
    console.log("byGeography");
    postalCodeTargetingBlock.style.display = "none";
    specificTargetsBlock.style.display = "none";
  }
  else if (chosenMethode == "none"){
    console.log("none, hide all");
    //hide all blocks
    postalCodeTargetingBlock.style.display = "none";
    specificTargetsBlock.style.display = "none";
  }
  else{
    /*Kept for old action, cf comment near function */
    console.log("Type of targetting not set - Testing depreciated method")
    visibilityControlerRepresentative(section);
  }
}

//Handle representative sections
/*
  DEPRECIATED AND REPLACED BY visibilityControlerTargettedMethod
  KEPT FOR OLD ACTIONS THAT HAVE NOT INFORMED THE CHOSEN METHOD VALUE

  KNOWN BUG -> When loading slowly, nothing is displayed 
 */
function visibilityControlerRepresentative(section){
  setTimeout(() => {
    representativeCTA = section.querySelector("u4e-multiple-js-button-representative-contact[name='targetedOfficials'] [name='name']");
    // console.log("representative visibility controler",section,representativeCTA);
    if (representativeCTA == null) {
      section.style.display = 'none';
    }else{
      section.style.display = 'block';
    }
  }, 1500);
}



//handle action step section
function visibilityControlerActionStep(section) {
  setTimeout(() => {
    stepContent = section.querySelector('u4e-multiple-action-steps > solid-display > div')?.innerText;
    // console.log("step content is",stepContent);
    if (stepContent){
      stepContent= stepContent.replace(/\s/g,"");
      stepContent= stepContent.replace(/\n/g,"");
      // console.log('step content is',stepContent);
      if (stepContent == '') {
        
        section.style.display = "none";
      }
      else{
        section.style.display = "block";
      }    
    }
    else{
      section.style.display = "none";
    }
  }, 0);
}

/***********************
        Action Steps
          * If active is True, add active class to element
          * Else hide section
***********************/
function styleActiveActionStep(solidDisplay){
  setTimeout(() => {
    //get all "active" fields in display
    activeFields = solidDisplay.querySelectorAll("u4e-display-active-step");
    // console.log("step fields",activeFields,solidDisplay);
    //if none, hide section
    if (!activeFields.length == 0) {
      activeFields.forEach(activeField => {
        activeFieldValue = activeField.getAttribute('value');
        //if Active is true, set "active" class to parent display
        if (activeFieldValue.toLowerCase() == 'true'){
          activeField.closest('solid-display').classList.add('active');
          // console.log(activeField.closest('solid-display').classList);
        }
      }); 
    }
  }, 2500);
}
/***********************
    LANGUAGE SWITCH         
***********************/
async function manageSelectLanguage() {
  let languageSelects = document.querySelectorAll(".languageChoice")
  console.log("language switches are",languageSelects);
  for (let item of languageSelects) {
    // console.log("language item",item);
    if (item.tagName == 'SOLID-FORM'){
      //We listen the selected option for the language
      item.addEventListener("change", async function() {
        languageRedirect(item,'form');
      })
    }
    else if (item.tagName == 'SOLID-DISPLAY'){
      flags = item.querySelectorAll("solid-display");
      flags.forEach(flag => {
        flag.addEventListener("click", async function(){
          languageRedirect(flag,'display');
        });
      });
    }
  }
}
async function languageRedirect(item,tagType){
  //We retrieve element of the url
  var pathAfterThePrefix = window.location.pathname.split('/')[2];
  if (pathAfterThePrefix == undefined){
    // console.log("on home");
    pathAfterThePrefix = "";
  }
  // console.log("path",pathAfterThePrefix,window.location.pathname);
  var baseUrl = location.protocol + '//' + location.host
  //if it's a form
  if (tagType == 'form'){
    //If the selected language is french
    let languagesList = await item.component.resource['ldp:contains'];
    // console.log("language list",languagesList)
    languagesList.forEach(async (resource) => {
      if (item.component.value.country['@id'] == resource['@id']) {
        if ((await resource.country) == 'Global'){
          var redirect = baseUrl + '/' + pathAfterThePrefix;
        }
        else{
          //sibStore.selectLanguage((await resource.code).toLowerCase());
          // console.log("resource country",(await resource.country));
          var redirect = baseUrl + '/' + (await resource.country).toLowerCase() + '/'+pathAfterThePrefix
        }
        document.location.href = redirect
      }
    });
  }
  else if (tagType == 'display'){
      language = item.querySelector("[name=country]").textContent;
      language = language.toLowerCase();
      if (language == 'global'){
        var redirect = "#";
        window.scrollTo({ top: 0,behavior: 'smooth',});
      }
      else{
        var redirect = baseUrl + '/' + language  + '/'+pathAfterThePrefix
      }
      document.location.href = redirect
  }
}



/***********************
        MAP SEARCH & INPUT
***********************/

async function solidMapSearch(clickLocation){
  let inputForm = clickLocation.parentElement.closest("solid-form");
  let inputStreet = inputForm.querySelector("input[name='road']").value;
  inputStreetEncoded = encodeURI(inputStreet);
  let inputCity = inputForm.querySelector("input[name='city']").value;
  inputCityEncoded = encodeURI(inputCity);
  let searchLoader = inputForm.querySelector("u4e-forms-display[name='searchLoader']")

  requestUrl = "https://nominatim.openstreetmap.org/search?q="+inputStreetEncoded+",+"+inputCityEncoded+"+&format=json&polygon=1&addressdetails=1"
  // console.log("location is",inputStreet,inputCity,requestUrl);
  
  searchLoader.style.display = 'block';
  const response = await fetch("https://nominatim.openstreetmap.org/search?q="+inputStreet+",+"+inputCity+"+&format=json&polygon=1&addressdetails=1")
  var data = await response.json();
  searchLoader.style.display = 'none';
  // console.log("response",data);

  try {
    //get values from response
    let locationName = data[0].display_name;
    //display hide error block, display validation && add lat/lng
    inputForm.querySelector("u4e-forms-display-label[name='locationError']").style.display = 'none';
    inputForm.querySelector("div[name='locationValidator']").textContent = locationName;
    inputForm.querySelector("u4e-forms-display-label[name='locationValidator']").style.display = 'block'
    inputForm.querySelector("u4e-forms-display-label[name='locationValidator2']").style.display = 'block'
    
    let locationLat = data[0].lat;
    let locationLon = data[0].lon;
    let city = data[0].address['city'];
    if (city == undefined ){
      city = data[0].address['town'];
      // console.log("in if",city);
    }
    if (city == undefined ){
      city = inputCity;
    }
    // console.log("original lats",data[0],city,locationLat,locationLon);
    //fill form values with responses
    inputForm.querySelector("input[name=lat]").value = parseFloat(locationLat).toFixed(12);
    inputForm.querySelector("input[name=lng]").value = parseFloat(locationLon).toFixed(12);
    inputForm.querySelector("input[name=city]").value = city;
 
  } catch (e) {
    //if error, display error block
    let locationName = inputStreet + " " + inputCity;
    if (locationName == " " ){
      locationName = "None";
    }
    inputForm.querySelector("div[name='locationError'] p").textContent = locationName;
    inputForm.querySelector("u4e-forms-display-label[name='locationError']").style.display = 'block';
    inputForm.querySelector("u4e-forms-display-label[name='locationValidator']").style.display = 'none'
    inputForm.querySelector("u4e-forms-display-label[name='locationValidator2']").style.display = 'none'
  }
}
function formatMapResult(feature) {
  // console.log("format map script");
  let address = feature.properties;
  let name = "";

  name += address.name ? address.name + " " : "";
  name += address.housenumber ? address.housenumber + " " : "";
  name += address.street ? address.street + ", " : "";
  name += address.city ? address.city + " " : "";
  name += address.postcode ? address.postcode + ", " : "";
  name += address.country ? address.country : "";

  return name;
}
